#ifndef _GL_WINDOW_H
#define _GL_WINDOW_H

#include <FL/Fl_Gl_Window.H>
#include <FL/Fl.H>
#include "vtkPolyData.h"
#include "partSys.h"

class GL_Window : public Fl_Gl_Window {
public:
	GL_Window(int,int,int,int,const char *l = 0);	

	int handle(int);
	void draw();
	void display();
	void load();
	void drawModel(vtkPolyData* m_polydata, float,float,float,float);

	float isoval;
	partSys *particles;
	
	
	int angle;
	vtkPolyData *bone_polydata;
	vtkPolyData *skin_polydata;
	float GALPHA;
	int drawBone, drawSkin;
};

#endif //_GL_WINDOW_H
