#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <stdio.h>
#include <vector>
#ifndef __PART_SYS_H
#define __PART_SYS_H
class Particle{
public:
	float pos[3]; 
	float vel[3];
	float strength;
	int ttd; // this is the time until it is dead, if this is 0 then we
	//don't talk to it anymore
    int dead;

inline Particle(){
		ttd = 0;
		strength = 0;
		pos[0] = pos[1] = pos[2] = vel[0] = vel[1] = vel[2] = 0;

        dead = 0;
        
};

};




class partSys{
public:
	float dt; // delta t, i.e. the time step
	float ax, ay, az; // accelerations in the cardinal vectorS
	float default_strength;
	float emmiter_pos[3];
	float initial_vector[3];
	float spread; // in %
	Particle** Plist; 
	float get_value_atv(float*);
	float ttdv; // time to die variaton;
	float ivv;  // initial vector variation;
				// the closer this is to one, the more
				// variation there is on initial vector.
	float scale;				
	
	
	
	int num_part;	
//	int* dead_list; //contains references into Plist of particles that are
	//	dead, i.e can be used for new particles that are emitted;

//	int last_dead; // this is the last dead particle in the dead_list, i.e.
	// the next one that will be emited
	
	int num_alive;
	int num_dead;

	float cg,cb,cr;
	
	
	// when created, a particle system has a certain
	//	number of particles. This is calculated by multiplying the default
	//	life times the rate, ( i.e. 30 particles per update times 10
	//	updates per particle means 90 particles). 
	//	if the user wishes to vary the rate or life, it can only be varied
	//	down. 

	partSys();
    partSys(int, int);	
	
inline	void set_rate(int d){
		rate = d;
	};

inline	int get_rate(){ return rate;};
inline	void set_default_life(int d){
		default_life = d;
	};

inline	int get_default_life(){
		return default_life;
	};	
	void update(); // this is where the meat of the particle system is
	//contained. It emits rate number of particles, 

	void drawIt();
	void emit(); // EMIT RATE PARTICLES
private:
	int rate;
	int default_life;
	
	
 	
	
};

#endif
	
